const { checkParams, resetCache } = require('./helpers');

//TODO: use WeakMap to store cache obj
const initProxy = (params = {}) => {
  checkParams(params);
  const { cacheRefresh, cacheElemRefresh } = params;
  const handler = {
    get: function (obj, prop) {
      const cacheValue = obj[prop] && obj[prop].value;
      if (cacheValue && resetCache({ obj, prop, cacheRefresh, cacheElemRefresh })) return null;
      else if (cacheValue) return cacheValue;
      return Reflect.get(obj, prop);
    },
    set: function (obj, prop, value) {
      if (Object.keys(obj).length === 0) {
        if (process.env.DEBUG) {
          console.log(`set cache for the first time for ${value}`);
        }
        obj.createdAt = new Date();
      }
      const newItem = { value, createdAt: new Date() };
      return Reflect.set(obj, prop, newItem);
    }
  };

  return new Proxy({}, handler);
};

module.exports = initProxy;
